\   Blue Code in Paper
\   Module to load into current version

vocabulary bluecode
bluecode also definitions

\    Preliminaries

: GLIMITS  For-All-Elements ; \ not quite
: EORDER   EleOrder ;

\  New

  0 CONSTANT /A       1 CONSTANT /B
  2 CONSTANT /C       3 CONSTANT /D
  4 CONSTANT /E       5 CONSTANT /F
  6 CONSTANT /G       7 CONSTANT /H
  8 CONSTANT /I       9 CONSTANT /J
 10 CONSTANT /K      11 CONSTANT /L
 12 CONSTANT /M      13 CONSTANT /N
 14 CONSTANT /O      15 CONSTANT /P
 16 CONSTANT /Q      17 CONSTANT /R
 18 CONSTANT /S      19 CONSTANT /T
 20 CONSTANT /U      21 CONSTANT /V
 22 CONSTANT /W      23 CONSTANT /X
 24 CONSTANT /Y      25 CONSTANT /Z
 26 CONSTANT /[      27 CONSTANT /\
 28 CONSTANT /]      29 CONSTANT /^
 30 CONSTANT /_      31 CONSTANT /`

: {   ( -- set ;;; interpret string up to } as a set )
      0                              \ start with empty set
      ASCII }  WORD                  \ get string up to }
      COUNT 2DUP UPPER               \ convert to upper case
      0 DO  DUP C@ ID -   DUP 0 15 BETWEEN  \ check if valid
          IF    ROT MEMBER! SWAP     \ set addr
          ELSE  DROP        THEN  1+ \ next address
        LOOP  DROP
      STATE @  IF  [COMPILE] LITERAL  THEN  ; IMMEDIATE


: ORDERS1 ( grp# -- )   >GROUP OCLEAR
      GLIMITS DO I EORDER +OCNT LOOP
      GNUM 3 .R  GORD 3 .R  2 SPACES
      20 1 DO
              GORD I MOD 0=
              IF  I 'OCNT @ . THEN
           LOOP  ;

:  COMMA   ASCII , EMIT ;
: QUOTES   ASCII " EMIT ;

: ORDERS2  ( grp# --  )  CR >GROUP
       ." Group number " GNUM .
       ." of Order " GORD .  CR  OCLEAR
    GLIMITS  DO  I EORDER DUP +OCNT I ORD!  LOOP
    GORD 1+ 1 DO  GORD I MOD 0=
          IF  3 SPACES  I 'OCNT @ 2 .R
              ."  elements of order "  I 2 .R ." :   "
              GLIMITS  DO I 'ORD @ J =
                           IF  I .ELE THEN
                        LOOP CR
          THEN  LOOP ;

comment:
\  This requires the older definition of elements
\  and G*

: POWERS
       ID  GLIMITS
       DO DUP .ELE  OVER G*
          DUP ID =
          IF 2DROP LEAVE THEN
       LOOP ;
comment;

: POWERS
       Ident  GLIMITS
       DO DUP .ELE  OVER G*
          DUP Ident =
          IF 2DROP LEAVE THEN
       LOOP ;

: Abelian1? ( -- t/f ) \ is current group abelian?
     TRUE
     GLIMITS DO  GLIMITS DO
         J I G* I J G*  <>
         IF DROP FALSE THEN
     LOOP LOOP ;

: #Commuting  ( grp -- n )  >GROUP
       0
       GLIMITS DO   GLIMITS DO
       J I G*  I J G* =
       IF 1+ THEN
       LOOP LOOP ;

comment:
\  This requires the older definition of elements
\  and G*

CREATE SQ  20 ALLOT
: #SQUARES  ( grp# -- n )  >GROUP
    SQ 20 ERASE
    GLIMITS DO
         I I G* ID - SQ + 1 SWAP C!
            LOOP
    0
    20 0 DO SQ I + C@  + LOOP ;

: SQUARES  ( grp# --  )  >GROUP
    SQ 20 ERASE
    GLIMITS DO
         I I G* ID - SQ + 1 SWAP C!
            LOOP
    20 0 DO SQ I + C@
            IF I ID + .ELE THEN
         LOOP ;
comment;

CREATE SQ  20 ALLOT
: #SQUARES  ( grp# -- n )  >GROUP
    SQ 20 ERASE
    GLIMITS DO
         I I G* Ident - SQ + 1 SWAP C!
            LOOP
    0
    20 0 DO SQ I + C@  + LOOP ;

: SQUARES  ( grp# --  )  >GROUP
    SQ 20 ERASE
    GLIMITS DO
         I I G* Ident - SQ + 1 SWAP C!
            LOOP
    20 0 DO SQ I + C@
            IF I Ident + .ELE THEN
         LOOP ;

\  First attempt at subgroups

CREATE SGTABLE  40 ALLOT
: SG.  SGTABLE COUNT 0
     ?DO DUP C@ .ELE 1+ LOOP
     DROP CR ;

: SG@  ( k - ele[k] )
     SGTABLE 1+ + C@  ;

:  SG-INIT  SGTABLE 40 ERASE  ;

:  >SGTABLE  ( ele -- )
  DUP SGTABLE COUNT + C!
  SGTABLE COUNT + 1+
  SGTABLE 1+ DO
    I C@ OVER =
    IF  DROP I LEAVE THEN  LOOP
    SGTABLE COUNT + =
    IF  SGTABLE C@ 1+
        SGTABLE C!  THEN  ;

: SGORD ( -- sgord)
       SGTABLE C@  ;

: SG*  ( k1 k2 - prod )
    SG@ SWAP SG@ SWAP G* ;

: SGSWEEP
   SGORD 0=
   ABORT"  Table is Empty "
   BEGIN  SGORD
     SGORD 0  DO  SGORD 0 DO
         J I SG*  >SGTABLE
     LOOP LOOP
          SGORD =  UNTIL  ;

: SGFIRST ( ele -- )
     SG-INIT >SGTABLE
     SGSWEEP SG. ;

: SGNEXT ( ele -- )
     >SGTABLE SGSWEEP SG.  ;


: Abelian2?  ( -- t/f )   \ is current group abelian?
           CENTER SET-G =  ;

: IsAnOrder? ( n - t/f )  \ is n the order of some element?
     \ Assume CALC-ORDERS has been run
     FALSE   ( n flag )
     MaxOrd 0 DO  OVER I 'ORD @ =
                  IF DROP TRUE THEN
              LOOP  SWAP DROP ;

: Cyclic?  ( grp# -- t/f )
       >GROUP CALC-ORDERS
       GORD IsAnOrder?  ;

: OfOrder ( n - ele t | f )  \ find element of order n
     FALSE   ( n flag )
     For-All-Elements
     DO  OVER I EleOrder =
         IF 2DROP I TRUE LEAVE THEN
     LOOP
     DUP 0= IF SWAP DROP THEN ;

\ 0 CONSTANT Empty-Set
: OrderN  ( n -- set ) \ set of all elements of order n
       Empty-Set  ( n set )
       For-All-Elements  DO
           OVER I EleOrder =
           IF  I SWAP Member! THEN
       LOOP  SWAP DROP ;

\  steps in dihedral


: Oops-Dihedral?  ( grp# -- t/f )
  \  if n is the order of the group G
  \  there must be elements of order 2 and n/2
  \  and G must be non-abelian
   >GROUP  CALC-ORDERS
   Abelian1?  NOT
   2 IsAnOrder? AND
   GORD 2 / IsAnOrder?  AND  ;

: Dihedral1?  ( grp# -- t/f )
      >GROUP  FALSE
      For-All-Elements DO  For-All-Elements DO
          I EleOrder 2 =
          J EleOrder Gord 2/ =  AND
          J I G* J G*   I =     AND
          IF DROP TRUE THEN
      LOOP LOOP ;

: ?IF    POSTPONE IF  ;  IMMEDIATE
: ?THEN  POSTPONE ELSE  POSTPONE FALSE
         POSTPONE THEN ; IMMEDIATE


: Dihedral2?  ( grp# -- t/f )
      >GROUP  FALSE
      For-All-Elements DO  For-All-Elements DO
               I EleOrder 2 =
          ?IF  J EleOrder Gord 2/ =  ?THEN
          ?IF  J I G* J G*   I =     ?THEN
          IF DROP TRUE THEN
      LOOP LOOP ;

: Dihedral3?  ( grp# -- t/f )
      >GROUP  FALSE
      For-All-Elements DO  For-All-Elements DO
               I EleOrder 2 =
          ?IF  J EleOrder Gord 2/ =  ?THEN
          ?IF  J I G* J G*   I =     ?THEN
          IF DROP TRUE
             UNLOOP UNLOOP EXIT
          THEN
      LOOP LOOP ;

: Dihedral4?  ( grp# -- t/f )
      >GROUP  FALSE
      For-All-Elements DO
          I EleOrder 2 =
          IF  For-All-Elements DO
              I EleOrder Gord 2/ =
              ?IF  I J G* I G*   J = ?THEN
              IF DROP TRUE
                 UNLOOP UNLOOP EXIT
              THEN
              LOOP
          THEN
       LOOP  ;

CREATE DIHEDS  MaxTables ALLOT  \ number of groups

: 'DIHED  ( grp# -- addr )
        DIHEDS + ;

: Old-Dihedral?  Dihedral1? ;

: Dihedral5?  ( grp# -- t/f )
        'DIHED C@ ;

: Calc-Dihedral
         DIHEDS MaxTables ERASE
         For-All-Groups DO
             I Old-Dihedral? I 'DIHED C!
         Loop ;
Calc-Dihedral


\   First attempt at permutation package

33 CONSTANT PMaxSize ( largest n for permutations )
                      \ +1 for count

: MakePERM   CREATE  PmaxSize ALLOT ;

: PInit  ( n perm -- )
      2DUP 0 SWAP Send!  SWAP 1+ 1
     ?DO   I DUP 2 PICK Send!   LOOP  DROP ;

: P.  ( perm -- )   \ print showing images of 1..n
      ." {  " DUP Degree 1+ 1
      DO  I OVER Sends .  LOOP  DROP ." }"  CR ;

: P!  ( x1 .. xn n perm  -- )   2DUP Degree!
    1 ROT DO  I OVER >R SWAP Send! R>  -1 +LOOP DROP ;

MakePerm Result
: oP*  ( perm1 perm2 -- result )
     Direction
     DUP Degree
     DUP  Result Degree!   1+ 1
     DO ( perm2 perm1 )
        I 2 PICK  Sends  ( perm2 perm1 perm2[I] )
        OVER Sends   ( perm2 perm1 perm1[perm2[I]] )
         I Result Send!
     LOOP   2DROP  Result  ;

5 VALUE PSize
: <<  GetRes  PSize Result PInit
              DEPTH SvDepth !  ;
: >>  DUP >R  DEPTH SvDepth @ - 1
      DO  OVER Result Send!  LOOP
      R>  Result Send!  Result  ;

: Perm:  ( use single parentheses in following string )
       PTemp PSize OVER PInit
       BEGIN   <<  ASCII ( PARSE 2DROP
                   ASCII ) PARSE EVALUATE
                DEPTH SvDepth @ -     WHILE
               >>  P*                 REPEAT ;



